diff --git a/sys/gnu/vfs/ext2fs/ext2_quota.c b/sys/gnu/vfs/ext2fs/ext2_quota.c
index 7f3b388..b103edb 100644
--- a/sys/gnu/vfs/ext2fs/ext2_quota.c
+++ b/sys/gnu/vfs/ext2fs/ext2_quota.c
@@ -765,7 +765,6 @@ ext2_dqget(struct vnode *vp, u_long id, struct ext2mount *ump, int type,
 	 * Initialize the contents of the dquot structure.
 	 */
 	if (vp != dqvp)
-		vn_lock(dqvp, LK_EXCLUSIVE | LK_RETRY);
 	LIST_INSERT_HEAD(dqh, dq, dq_hash);
 	DQREF(dq);
 	dq->dq_flags = DQ_LOCK;
@@ -797,7 +796,6 @@ ext2_dqget(struct vnode *vp, u_long id, struct ext2mount *ump, int type,
 		LIST_REMOVE(dq, dq_hash);
 		ext2_dqrele(vp, dq);
 		*dqp = NODQUOT;
-		return (error);
 	}
 	/*
 	 * Check for no limit to enforce.
@@ -813,7 +811,6 @@ ext2_dqget(struct vnode *vp, u_long id, struct ext2mount *ump, int type,
 			dq->dq_itime = time_second + ump->um_itime[type];
 	}
 	*dqp = dq;
-	return (0);
 }
 
 #ifdef DIAGNOSTIC
@@ -864,14 +861,12 @@ ext2_dqsync(struct vnode *vp, struct ext2_dquot *dq)
 	if ((dqvp = dq->dq_ump->um_quotas[dq->dq_type]) == NULLVP)
 		panic("dqsync: file");
 	if (vp != dqvp)
-		vn_lock(dqvp, LK_EXCLUSIVE | LK_RETRY);
 	while (dq->dq_flags & DQ_LOCK) {
 		dq->dq_flags |= DQ_WANT;
 		(void) tsleep((caddr_t)dq, 0, "dqsync", 0);
 		if ((dq->dq_flags & DQ_MOD) == 0) {
 			if (vp != dqvp)
 				vn_unlock(dqvp);
-			return (0);
 		}
 	}
 	dq->dq_flags |= DQ_LOCK;
@@ -892,7 +887,6 @@ ext2_dqsync(struct vnode *vp, struct ext2_dquot *dq)
 	dq->dq_flags &= ~(DQ_MOD|DQ_LOCK|DQ_WANT);
 	if (vp != dqvp)
 		vn_unlock(dqvp);
-	return (error);
 }
 
 /*
diff --git a/sys/gnu/vfs/ext2fs/ext2_vfsops.c b/sys/gnu/vfs/ext2fs/ext2_vfsops.c
index 5e43be8..ed1475f 100644
--- a/sys/gnu/vfs/ext2fs/ext2_vfsops.c
+++ b/sys/gnu/vfs/ext2fs/ext2_vfsops.c
@@ -389,10 +389,8 @@ ext2_mount(struct mount *mp, char *path, caddr_t data, struct ucred *cred)
 		accessmode = VREAD;
 		if ((mp->mnt_flag & MNT_RDONLY) == 0)
 			accessmode |= VWRITE;
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY);
 		if ((error = VOP_EACCESS(devvp, accessmode, cred)) != 0) {
 			vput(devvp);
-			return (error);
 		}
 		vn_unlock(devvp);
 	}
diff --git a/sys/kern/vfs_conf.c b/sys/kern/vfs_conf.c
index bfa4e7a..590b34e 100644
--- a/sys/kern/vfs_conf.c
+++ b/sys/kern/vfs_conf.c
@@ -310,7 +310,6 @@ vfs_mountroot_devfs(void)
 	 */
 	error = VFS_MOUNT(mp, "/dev", NULL, cred);
 
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);
 
 	/*
 	 * Put the new filesystem on the mount list after root.  The mount
@@ -361,7 +360,6 @@ vfs_mountroot_devfs(void)
 	}
 
 	devfs_debug(DEVFS_DEBUG_DEBUG, "rootmount_devfs done with error: %d\n", error);
-	return (error);
 }
 
 
diff --git a/sys/kern/vfs_lookup.c b/sys/kern/vfs_lookup.c
index 67dfbab..0b253e24 100644
--- a/sys/kern/vfs_lookup.c
+++ b/sys/kern/vfs_lookup.c
@@ -82,7 +82,6 @@ relookup(struct vnode *dvp, struct vnode **vpp, struct componentname *cnp)
 	 */
 	KKASSERT(cnp->cn_flags & CNP_LOCKPARENT);
 	KKASSERT(cnp->cn_flags & CNP_PDIRUNLOCK);
-	vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY);
 	cnp->cn_flags &= ~CNP_PDIRUNLOCK;
 
 	*vpp = NULL;
@@ -123,7 +122,6 @@ relookup(struct vnode *dvp, struct vnode **vpp, struct componentname *cnp)
 		 * doesn't currently exist, leaving a pointer to the
 		 * (possibly locked) directory inode in ndp->ni_dvp.
 		 */
-		return (0);
 	}
 
 	/*
@@ -141,7 +139,6 @@ relookup(struct vnode *dvp, struct vnode **vpp, struct componentname *cnp)
 		goto bad;
 	}
 	KKASSERT((cnp->cn_flags & CNP_PDIRUNLOCK) == 0);
-	return (0);
 
 bad:
 	if ((cnp->cn_flags & CNP_PDIRUNLOCK) == 0) {
@@ -152,6 +149,5 @@ bad:
 		vput(*vpp);
 		*vpp = NULL;
 	}
-	return (error);
 }
 
diff --git a/sys/kern/vfs_syscalls.c b/sys/kern/vfs_syscalls.c
index e030d89..09046f6 100644
--- a/sys/kern/vfs_syscalls.c
+++ b/sys/kern/vfs_syscalls.c
@@ -385,7 +385,6 @@ update:
 		cache_drop(&nch);
 		goto done;
 	}
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);
 
 	/*
 	 * Put the new filesystem on the mount list after root.  The mount
@@ -433,7 +432,6 @@ update:
 		vput(vp);
 	}
 done:
-	return (error);
 }
 
 /*
@@ -1565,7 +1563,6 @@ sys_fchdir(struct fchdir_args *uap)
 	lwkt_gettoken(&p->p_token);
 	vp = (struct vnode *)fp->f_data;
 	vref(vp);
-	vn_lock(vp, LK_SHARED | LK_RETRY);
 	if (fp->f_nchandle.ncp == NULL)
 		error = ENOTDIR;
 	else
@@ -1611,7 +1608,6 @@ sys_fchdir(struct fchdir_args *uap)
 	fdrop(fp);
 done:
 	lwkt_reltoken(&p->p_token);
-	return (error);
 }
 
 int
@@ -3624,7 +3620,6 @@ kern_ftruncate(int fd, off_t length)
 		goto done;
 	}
 	vp = (struct vnode *)fp->f_data;
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);
 	if (vp->v_type == VDIR) {
 		error = EISDIR;
 		goto done;
@@ -3648,7 +3643,6 @@ kern_ftruncate(int fd, off_t length)
 	vn_unlock(vp);
 done:
 	fdrop(fp);
-	return (error);
 }
 
 /*
@@ -4359,7 +4353,6 @@ sys_fhopen(struct fhopen_args *uap)
 	}
 	if (fmode & O_TRUNC) {
 		vn_unlock(vp);				/* XXX */
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);	/* XXX */
 		VATTR_NULL(vap);
 		vap->va_size = 0;
 		error = VOP_SETATTR(vp, vap, td->td_ucred);
@@ -4439,7 +4432,6 @@ sys_fhopen(struct fhopen_args *uap)
 	uap->sysmsg_result = indx;
 	if (uap->flags & O_CLOEXEC)
 		error = fsetfdflags(fdp, indx, UF_EXCLOSE);
-	return (error);
 
 bad_drop:
 	fsetfd(fdp, NULL, indx);
@@ -4447,7 +4439,6 @@ bad_drop:
 bad:
 	vput(vp);
 done:
-	return (error);
 }
 
 /*
diff --git a/sys/kern/vfs_vnops.c b/sys/kern/vfs_vnops.c
index 152b372..e217d24 100644
--- a/sys/kern/vfs_vnops.c
+++ b/sys/kern/vfs_vnops.c
@@ -247,7 +247,6 @@ again:
 	}
 	if (fmode & O_TRUNC) {
 		vn_unlock(vp);				/* XXX */
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);	/* XXX */
 		osize = vp->v_filesize;
 		VATTR_NULL(vap);
 		vap->va_size = 0;
@@ -336,11 +335,9 @@ again:
 	} else {
 		vput(vp);
 	}
-	return (0);
 bad:
 	if (vp)
 		vput(vp);
-	return (error);
 }
 
 int
@@ -562,7 +559,6 @@ vn_rdwr(enum uio_rw rw, struct vnode *vp, caddr_t base, int len,
 	int error;
 
 	if ((ioflg & IO_NODELOCKED) == 0)
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);
 	auio.uio_iov = &aiov;
 	auio.uio_iovcnt = 1;
 	aiov.iov_base = base;
@@ -584,7 +580,6 @@ vn_rdwr(enum uio_rw rw, struct vnode *vp, caddr_t base, int len,
 			error = EIO;
 	if ((ioflg & IO_NODELOCKED) == 0)
 		vn_unlock(vp);
-	return (error);
 }
 
 /*
diff --git a/sys/vfs/devfs/devfs_vnops.c b/sys/vfs/devfs/devfs_vnops.c
index 2430be7..5d4c137 100644
--- a/sys/vfs/devfs/devfs_vnops.c
+++ b/sys/vfs/devfs/devfs_vnops.c
@@ -1030,7 +1030,6 @@ devfs_spec_close(struct vop_close_args *ap)
 	 * We do special tests on the opencount so unfortunately we need
 	 * an exclusive lock.
 	 */
-	vn_lock(vp, LK_UPGRADE | LK_RETRY);
 
 	if (dev)
 		devfs_debug(DEVFS_DEBUG_DEBUG,
@@ -1137,7 +1136,6 @@ devfs_spec_close(struct vop_close_args *ap)
 		release_dev(dev);
 	if (vp->v_opencount > 0)
 		vop_stdclose(ap);
-	return(error);
 
 }
 
diff --git a/sys/vfs/fifofs/fifo_vnops.c b/sys/vfs/fifofs/fifo_vnops.c
index 77098e5..121f6af 100644
--- a/sys/vfs/fifofs/fifo_vnops.c
+++ b/sys/vfs/fifofs/fifo_vnops.c
@@ -216,7 +216,6 @@ fifo_open(struct vop_open_args *ap)
 			vn_unlock(vp);
 			error = tsleep((caddr_t)&fip->fi_readers,
 			    PCATCH, "fifoor", 0);
-			vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);
 			if (error)
 				goto bad;
 			/*
@@ -251,13 +250,11 @@ fifo_open(struct vop_open_args *ap)
 	vsetflags(vp, VNOTSEEKABLE);
 	error = vop_stdopen(ap);
 	lwkt_reltoken(&vp->v_token);
-	return (error);
 bad:
 	vop_stdopen(ap);	/* bump opencount/writecount as appropriate */
 	VOP_CLOSE(vp, ap->a_mode, NULL);
 done:
 	lwkt_reltoken(&vp->v_token);
-	return (error);
 }
 
 /*
diff --git a/sys/vfs/isofs/cd9660/cd9660_vfsops.c b/sys/vfs/isofs/cd9660/cd9660_vfsops.c
index 2e43270..682f3d1 100644
--- a/sys/vfs/isofs/cd9660/cd9660_vfsops.c
+++ b/sys/vfs/isofs/cd9660/cd9660_vfsops.c
@@ -237,13 +237,11 @@ cd9660_mount(struct mount *mp, char *path, caddr_t data, struct ucred *cred)
 	 * or has superuser abilities
 	 */
 	accessmode = VREAD;
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY);
 	error = VOP_EACCESS(devvp, accessmode, cred);
 	if (error) 
 		error = priv_check_cred(cred, PRIV_ROOT, 0);
 	if (error) {
 		vput(devvp);
-		return (error);
 	}
 	vn_unlock(devvp);
 
diff --git a/sys/vfs/msdosfs/msdosfs_vfsops.c b/sys/vfs/msdosfs/msdosfs_vfsops.c
index 2faf7e1..b93c540 100644
--- a/sys/vfs/msdosfs/msdosfs_vfsops.c
+++ b/sys/vfs/msdosfs/msdosfs_vfsops.c
@@ -268,11 +268,9 @@ msdosfs_mount(struct mount *mp, char *path, caddr_t data, struct ucred *cred)
 		accessmode = VREAD;
 		if ((mp->mnt_flag & MNT_RDONLY) == 0)
 			accessmode |= VWRITE;
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY);
 		error = VOP_EACCESS(devvp, accessmode, cred);
 		if (error) {
 			vput(devvp);
-			return (error);
 		}
 		vn_unlock(devvp);
 	}
diff --git a/sys/vfs/udf/udf_vfsops.c b/sys/vfs/udf/udf_vfsops.c
index f0615a8..4817a09 100644
--- a/sys/vfs/udf/udf_vfsops.c
+++ b/sys/vfs/udf/udf_vfsops.c
@@ -173,13 +173,11 @@ udf_mount(struct mount *mp, char *path, caddr_t data, struct ucred *cred)
 	}
 
 	/* Check the access rights on the mount device */
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY);
 	error = VOP_EACCESS(devvp, VREAD, cred);
 	if (error)
 		error = priv_check_cred(cred, PRIV_ROOT, 0);
 	if (error) {
 		vput(devvp);
-		return(error);
 	}
 	vn_unlock(devvp);
 
diff --git a/sys/vfs/ufs/ffs_softdep.c b/sys/vfs/ufs/ffs_softdep.c
index 7be0069..62fe279 100644
--- a/sys/vfs/ufs/ffs_softdep.c
+++ b/sys/vfs/ufs/ffs_softdep.c
@@ -4063,14 +4063,11 @@ softdep_fsync(struct vnode *vp)
 		FREE_LOCK(&lk);
 		vn_unlock(vp);
 		error = VFS_VGET(mnt, NULL, parentino, &pvp);
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);
 		if (error != 0) {
-			return (error);
 		}
 		if (flushparent) {
 			if ((error = ffs_update(pvp, 1)) != 0) {
 				vput(pvp);
-				return (error);
 			}
 		}
 		/*
@@ -4081,14 +4078,12 @@ softdep_fsync(struct vnode *vp)
 			error = bwrite(bp);
 		vput(pvp);
 		if (error != 0) {
-			return (error);
 		}
 		ACQUIRE_LOCK(&lk);
 		if (inodedep_lookup(fs, ip->i_number, 0, &inodedep) == 0)
 			break;
 	}
 	FREE_LOCK(&lk);
-	return (0);
 }
 
 /*
diff --git a/sys/vfs/ufs/ffs_vfsops.c b/sys/vfs/ufs/ffs_vfsops.c
index d82176f..1130083 100644
--- a/sys/vfs/ufs/ffs_vfsops.c
+++ b/sys/vfs/ufs/ffs_vfsops.c
@@ -299,10 +299,8 @@ ffs_mount(struct mount *mp,		/* mount struct pointer */
 		accessmode = VREAD;
 		if ((mp->mnt_flag & MNT_RDONLY) == 0)
 			accessmode |= VWRITE;
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY);
 		if ((error = VOP_EACCESS(devvp, accessmode, cred)) != 0) {
 			vput(devvp);
-			return (error);
 		}
 		vn_unlock(devvp);
 	}
diff --git a/sys/vfs/ufs/ufs_quota.c b/sys/vfs/ufs/ufs_quota.c
index fa3627a..d96a5ca 100644
--- a/sys/vfs/ufs/ufs_quota.c
+++ b/sys/vfs/ufs/ufs_quota.c
@@ -803,7 +803,6 @@ ufs_dqget(struct vnode *vp, u_long id, struct ufsmount *ump, int type,
 	 * Initialize the contents of the dquot structure.
 	 */
 	if (vp != dqvp)
-		vn_lock(dqvp, LK_EXCLUSIVE | LK_RETRY);
 	LIST_INSERT_HEAD(dqh, dq, dq_hash);
 	DQREF(dq);
 	dq->dq_flags = DQ_LOCK;
@@ -835,7 +834,6 @@ ufs_dqget(struct vnode *vp, u_long id, struct ufsmount *ump, int type,
 		LIST_REMOVE(dq, dq_hash);
 		ufs_dqrele(vp, dq);
 		*dqp = NODQUOT;
-		return (error);
 	}
 	/*
 	 * Check for no limit to enforce.
@@ -851,7 +849,6 @@ ufs_dqget(struct vnode *vp, u_long id, struct ufsmount *ump, int type,
 			dq->dq_itime = time_second + ump->um_itime[type];
 	}
 	*dqp = dq;
-	return (0);
 }
 
 #ifdef DIAGNOSTIC
@@ -902,14 +899,12 @@ ufs_dqsync(struct vnode *vp, struct ufs_dquot *dq)
 	if ((dqvp = dq->dq_ump->um_quotas[dq->dq_type]) == NULLVP)
 		panic("dqsync: file");
 	if (vp != dqvp)
-		vn_lock(dqvp, LK_EXCLUSIVE | LK_RETRY);
 	while (dq->dq_flags & DQ_LOCK) {
 		dq->dq_flags |= DQ_WANT;
 		(void) tsleep((caddr_t)dq, 0, "dqsync", 0);
 		if ((dq->dq_flags & DQ_MOD) == 0) {
 			if (vp != dqvp)
 				vn_unlock(dqvp);
-			return (0);
 		}
 	}
 	dq->dq_flags |= DQ_LOCK;
@@ -930,7 +925,6 @@ ufs_dqsync(struct vnode *vp, struct ufs_dquot *dq)
 	dq->dq_flags &= ~(DQ_MOD|DQ_LOCK|DQ_WANT);
 	if (vp != dqvp)
 		vn_unlock(dqvp);
-	return (error);
 }
 
 /*
diff --git a/sys/vfs/union/union_subr.c b/sys/vfs/union/union_subr.c
index c2260c9..1131807 100644
--- a/sys/vfs/union/union_subr.c
+++ b/sys/vfs/union/union_subr.c
@@ -429,7 +429,6 @@ loop:
 				vn_unlock(dvp);
 				error = vn_lock(un->un_vnode, LK_EXCLUSIVE |
 							      LK_FAILRECLAIM);
-				vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY);
 				vrele(dvp);
 			} else {
 				/*
@@ -512,7 +511,6 @@ loop:
 		}
 
 		*vpp = UNIONTOV(un);
-		return (0);
 	}
 
 	if (docache) {
@@ -590,7 +588,6 @@ out:
 	if (docache)
 		union_list_unlock(hash);
 
-	return (error);
 }
 
 int
@@ -746,7 +743,6 @@ union_copyup(struct union_node *un, int docopy, struct ucred *cred,
 		 * XX - should not ignore errors
 		 * from VOP_CLOSE
 		 */
-		vn_lock(lvp, LK_EXCLUSIVE | LK_RETRY);
 		error = VOP_OPEN(lvp, FREAD, cred, NULL);
 		if (error == 0) {
 			error = union_copyfile(lvp, uvp, cred, td);
@@ -784,7 +780,6 @@ union_copyup(struct union_node *un, int docopy, struct ucred *cred,
 		un->un_openl = 0;
 	}
 
-	return (error);
 
 }
 
diff --git a/sys/vfs/union/union_vnops.c b/sys/vfs/union/union_vnops.c
index 479aa0b..1945b77 100644
--- a/sys/vfs/union/union_vnops.c
+++ b/sys/vfs/union/union_vnops.c
@@ -475,7 +475,6 @@ union_lookup(struct vop_old_lookup_args *ap)
 		if ((cnp->cn_flags & CNP_ISDOTDOT) && dun->un_pvp != NULLVP) {
 			if ((lowervp = LOWERVP(dun->un_pvp)) != NULL) {
 				vref(lowervp);
-				vn_lock(lowervp, LK_EXCLUSIVE | LK_RETRY);
 				lerror = 0;
 			}
 		}
@@ -622,7 +621,6 @@ out:
 	}
 #endif
 
-	return (error);
 }
 
 /*